<?php
/*
$LastChangedDate: 2013-02-17 13:09:35 -0700 (Sun, 17 Feb 2013) $
$Rev: 9856 $
*/

function sp_plupload_do_uploader_form($out, $fid, $uid='', $pid='', $type='') {
	global $sfglobals, $sfvars, $spThisUser, $spThisTopic, $SFMOBILE;

    # dont use uploader for mobile devices
//    if ($SFMOBILE) return $out;

	if (($sfvars['pageview']=='forum' || $sfvars['pageview']=='topic') && $sfglobals['display']['editor']['toolbar']) {
		$toolbar = true;
		$class = ' class="spInlineSection"';
	} else {
		$toolbar = false;
	}

    sp_plupload_config($spThisUser);
    global $plup;

    $uploads = sp_get_option('spPlupload');

    # clean up some inputs
    $forumid = (is_object($fid)) ? $fid->forum_id : $fid;
    if (empty($ui)) $uid = $spThisUser->ID;

	# permissions check for uploader and allowed types
	$canUpload = false;
	$filters = '[ ';
    $uploadImages = ((sp_get_auth('upload_images', $forumid) && (empty($type) || $type == 'edit')) || (sp_get_auth('upload_signatures', '', $uid) && $type == 'sig') || $type == 'photos');
    $uploadMedia = (sp_get_auth('upload_media', $forumid) && (empty($type) || $type == 'edit'));
    $uploadFiles = (sp_get_auth('upload_files', $forumid) && (empty($type) || $type == 'edit'));
	if ($uploadImages) {
		$filters.= '{title : "'.esc_attr(__('Image files', 'sp-plup')).'", extensions : "'.str_replace(' ', '', $uploads['imagetypes']).'"}, ';
		$canUpload = true;
	}
	if ($uploadMedia) {
		$filters.= '{title : "'.esc_attr(__('Media files', 'sp-plup')).'", extensions : "'.str_replace(' ', '', $uploads['mediatypes']).'"}, ';
		$canUpload = true;
	}
	if ($uploadFiles) {
		$filters.= '{title : "'.esc_attr(__('Other files', 'sp-plup')).'", extensions : "'.str_replace(' ', '', $uploads['filetypes']).'"}';
		$canUpload = true;
	}
	if (!$canUpload) return $out;
	$filters.= ' ]';

	$tout='';
	if ($toolbar) $tout.= "<div id='spUploadsBox'$class>";

	$tout.= '<div class="spEditorSection sp_file_uploader">';
    $js = "spjToggleLayer('sp_file_uploader', 'fast');spjToggleLayer('sp_uploader_info', 'fast');";
    $js2 = "spjToggleLayer('sp_uploader_attachments', 'fast');";
    switch ($type) {
        case 'sig':
            $imageInsert = $uploads['imageinsert'];
            $mediaInsert = false;
            $item = 'signature';
            $button = __('Upload Image', 'sp-plup');
            $js.= "setTimeout(function() {spjSetProfileDataHeight();}, 250);";
            break;

        case 'photos':
            $imageInsert = false;
            $mediaInsert = false;
            $button = __('Upload Photos', 'sp-plup');
            $js.= "setTimeout(function() {spjSetProfileDataHeight();}, 500);";
            break;

        default:
            $imageInsert = $uploads['imageinsert'];
        	$item = 'postitem';
            $mediaInsert = $uploads['mediainsert'];
            $button = __('Upload Attachments', 'sp-plup');
            break;
    }
    $tout.= '<a class="spButton" id="spUploadToggle" onclick="'.$js.'" href="javascript:void(0);">'.$button.'</a>';
    if ($type == 'edit') {
    	$attachments = spdb_select('var', 'SELECT attachments FROM '.SFPOSTS." WHERE post_id=$pid");
        if (!empty($attachments)) $tout.= '<a class="spButton" onclick="'.$js2.'" href="javascript:void(0);">'.__('Remove Attachments', 'sp-plup').'</a>';
    }
    if ($type == 'photos') {
        $tout.= '<h3 class="spClear">'.__('After uploading photos, be sure to click on the Update Photos button', 'sp-plup').'</h3>';
    }
    $out.= apply_filters('sph_uploader_editor_section', $tout, $type, $uploadImages, $uploadMedia, $uploadFiles);
	$out.= '<div style="clear:both"></div>';
	$out.= '<div id="sp_file_uploader"></div>';

    $plup['type'] = $type;
    $plup['fid'] = $forumid;
?>
	<script type='text/javascript'>
	/* <![CDATA[ */
	var plup = {
		item : '<?php echo($item); ?>',
		imageInsert : '<?php echo($imageInsert); ?>',
		mediaInsert : '<?php echo($mediaInsert); ?>',
		filters : <?php echo($filters); ?>
	};
	/* ]]> */
	</script>
<?php
    if (empty($type) || $type == 'edit') {
    	add_action('wp_footer', 'sp_plupload_script');
    } else {
        $out.= sp_plupload_script(true);
    }

	$out.= '<div id="sp_uploader_errors"></div>';
	$out.= '<div id="sp_uploader_status"></div>';
	$out.= '<div id="sp_uploader_info">';
    $temp_out = '<table>';
	if ($uploadImages) {
        $temp_out.= '<tr>';
        $temp_out.= '<td class="plup-header">';
        $size = ($plup['maxsize']['image'] == 0) ? 'unlimited' : $plup['maxsize']['image'];
        $width = ($plup['imageresize']['width'] == 0) ? 'unlimited' : $plup['imageresize']['width'];
        $height = ($plup['imageresize']['height'] == 0) ? 'unlimited' : $plup['imageresize']['height'];
		$temp_out.= __('Image upload constraints', 'sp-plup').':';
        $temp_out.= '</td>';
        $temp_out.= '<td class="plup-data">';
        $temp_out.= __('Size (bytes)', 'sp-plup').':&nbsp;&nbsp;'.$size;
        $temp_out.= '</td>';
        $temp_out.= '<td class="plup-data">';
        $temp_out.= __('Width (pixels)', 'sp-plup').':&nbsp;&nbsp;'.$width;
        $temp_out.= '</td>';
        $temp_out.= '<td class="plup-data">';
        $temp_out.= __('Height (pixels)', 'sp-plup').':&nbsp;&nbsp;'.$height;
        $temp_out.= '</td>';
        $temp_out.= '</tr>';
        $temp_out.= '<tr>';
        $temp_out.= '<td class="plup-header">';
		$temp_out.= __('Image allowed types', 'sp-plup').':';
        $temp_out.= '</td>';
        $temp_out.= '<td class="plup-data" colspan="3">';
		$temp_out.= $uploads['imagetypes'];
        $temp_out.= '</td>';
        $temp_out.= '</tr>';
	}
	if ($uploadMedia) {
        $temp_out.= '<tr>';
        $temp_out.= '<td class="plup-header">';
        $size = ($plup['maxsize']['media'] == 0) ? 'unlimited' : $plup['maxsize']['media'];
        $width = ($plup['mediasize']['width'] == 0) ? 'unlimited' : $plup['mediasize']['width'];
        $height = ($plup['mediasize']['height'] == 0) ? 'unlimited' : $plup['mediasize']['height'];
		$temp_out.= __('Media upload constraints', 'sp-plup').':';
        $temp_out.= '</td>';
        $temp_out.= '<td class="plup-data">';
        $temp_out.= __('Size (bytes)', 'sp-plup').':&nbsp;&nbsp;'.$size;
        $temp_out.= '</td>';
        $temp_out.= '<td class="plup-data">';
        $temp_out.= __('Width (pixels)', 'sp-plup').':&nbsp;&nbsp;'.$width;
        $temp_out.= '</td>';
        $temp_out.= '<td class="plup-data">';
        $temp_out.= __('Height (pixels)', 'sp-plup').':&nbsp;&nbsp;'.$height;
        $temp_out.= '</td>';
        $temp_out.= '</tr>';
        $temp_out.= '<tr>';
        $temp_out.= '<td class="plup-header">';
		$temp_out.= __('Media allowed types', 'sp-plup').':';
        $temp_out.= '</td>';
        $temp_out.= '<td class="plup-data" colspan="3">';
		$temp_out.= $uploads['mediatypes'];
        $temp_out.= '</td>';
        $temp_out.= '</tr>';
	}
	if ($uploadFiles) {
        $temp_out.= '<tr>';
        $temp_out.= '<td class="plup-header">';
        $size = ($plup['maxsize']['file'] == 0) ? 'unlimited' : $plup['maxsize']['file'];
		$temp_out.= __('File upload constraints', 'sp-plup').':';
        $temp_out.= '</td>';
        $temp_out.= '<td class="plup-data" colspan="3">';
        $temp_out.= __('Size (bytes)', 'sp-plup').':&nbsp;&nbsp;'.$size;
        $temp_out.= '</td>';
        $temp_out.= '</tr>';
        $temp_out.= '<tr>';
        $temp_out.= '<td class="plup-header">';
		$temp_out.= __('File allowed types', 'sp-plup').':';
        $temp_out.= '</td>';
        $temp_out.= '<td class="plup-data" colspan="3">';
		$temp_out.= $uploads['filetypes'];
        $temp_out.= '</td>';
        $temp_out.= '</tr>';
	}

    $temp_out.= '</table>';
    $out.= apply_filters('sph_uploader_info', $temp_out);
    $out.= '</div>';

    if ($type == 'edit' && !empty($attachments)) {
    	$out.= '<div id="sp_uploader_attachments">';
        $post = spdb_table(SFPOSTS, "post_id=$pid", 'row');
        $out.= '<p class="spPlupHeaderTitle">'.__('Select attachment(s) you want to remove from this post', 'sp-plup').':</p>';
  		$out.= '<form action="'.sp_build_url($spThisTopic->forum_slug, $spThisTopic->topic_slug, '', $post->post_id, $post->post_index).' method="post" name="removepostattachments">';
        $out.= '<input type="hidden" name="currentpostid" value="'.$pid.'" />';
        $out.= '<input type="hidden" name="userid" value="'.$post->user_id.'" />';
        $out.= sp_plupload_render_attachment_list($post->attachments, false).'<br /><br />';
        $out.= '<input type="submit" class="spSubmit" name="removeattachments" value="'.esc_attr(__('Remove Attachments', 'sp-plup')).'" />';
        $out.= '<input type="button" class="spSubmit" name="cancel" value="'.esc_attr(__('Cancel', 'sp-plup')).'" onclick="jQuery(\'#dialog\').dialog(\'close\');" />';
        $out.= '<p class="spPlupHeaderTitle">'.__('WARNING: Any other edits to this post will be lost, so you may want to save them first', 'sp-plup');
        $out.= '<br />'.__('You will also need to manually remove the image from the post content', 'sp-plup').'</p>';
  		$out.= '</form>';
    	$out.= '</div>';
    }

	$out.= '</div>';
	if ($toolbar) $out.= "</div>";

	return $out;
}

function sp_plupload_script($get=false) {
    global $plup;

	$url = SFHOMEURL.'index.php?sp_ahah=plupload&sfnonce='.wp_create_nonce('forum-ahah').'&type='.$plup['type'].'&fid='.$plup['fid'];
	$url2 = SFHOMEURL.'index.php?sp_ahah=plupload-remove&;sfnonce='.wp_create_nonce('forum-ahah').'&fid='.$plup['fid'].'&name=';
    $runtimes = apply_filters('sph_plugload_runtimes' , 'html5,silverlight,flash,html4', $plup['type']);

    # get php max settings
    $max_upload = sp_plupload_return_bytes(ini_get('upload_max_filesize'));
    $max_post = sp_plupload_return_bytes(ini_get('post_max_size'));
    $max_file_size = min($max_upload, $max_post);

    $out = "
		<script type='text/javascript'>
			jQuery(document).ready(function() {
    			jQuery('#sp_file_uploader').plupload({
					runtimes : '$runtimes',
					url : '$url',
                    max_file_size : '$max_file_size',
					flash_swf_url : '".SPPLUPSCRIPT."plupload.flash.swf',
					silverlight_xap_url : '".SPPLUPSCRIPT."plupload.silverlight.xap',
					filters : plup.filters
				});
				var uploader = jQuery('#sp_file_uploader').plupload('getUploader');

				uploader.bind('FilesRemoved', function(up, files) {
					jQuery.get('$url2' + files[0]['name']);
				});

				uploader.bind('FileUploaded', function(up, file, response) {
					try {
						var msg;
						var status = jQuery.parseJSON(response.response);
						if (status['error']['code'] != 0) {
							msg = file.name + ': ".esc_attr(__('Error', 'sp-plup'))." ' + status['error']['code'] + ' - ' + status['error']['message'] + '<br />';
							jQuery('#sp_uploader_errors').append(msg);
							if (status['error']['code'] == 109) {
								uploader.unbind('FilesRemoved');
								up.removeFile(file);
								uploader.bind('FilesRemoved', function(up, files) {
									jQuery.get('$url2' + files[0]['name']);
								});
							} else {
								up.removeFile(file);
							}
						} else {
                            file.name = status['file'];
							var x = plup.imageInsert;
							var y = plup.mediaInsert;
							if (status['type'] == 'image' && x == '1') {
								spjEdInsertAttachment(status['file'], status['file'], '".esc_attr($plup['link']['image'])."', plup.item, status['width'], status['height']);
							} else if (status['type'] == 'media' && y == '1') {
								spjEdInsertMediaAttachment(status['file'], '".esc_attr($plup['link']['media'])."', '".esc_attr($plup['mediasize']['width'])."', '".esc_attr($plup['mediasize']['height'])."');
							}
    						jQuery('#sp_uploader_status').show().html('".esc_attr(__('Upload completed successfully', 'sp-plup'))."').fadeOut(5000);
						}
					}
					catch (e) {
						alert(e.message);
						msg = file.name + ': ".__('Error', 'sp-plup')." ".esc_attr(__('999 - Unknown server error (check image size - may be exhausting memory)', 'sp-plup'))."<br />';
						jQuery('#sp_uploader_errors').append(msg);
						up.removeFile(file);
					}
				});
			});
		</script>
    ";
    if ($get) {
        return $out;
    } else {
        echo $out;
    }
}

function sp_plupload_do_uploader_profile_form($userid) {
    $out = '';

    # display current photos
    $photos = get_user_meta($userid, 'sp_profile_photos', true);
    if ($photos) {
        $out.= '<table>';
        foreach ($photos as $index => $photo) {
            if (file_exists($photo['loc'].$photo['file'])) {
                $out.= "<tr id='sp-photo-$index'>";
                $out.= '<td class="spPlupPhoto"><img src="'.$photo['path'].$photo['file'].'" /></td>';
    	        $site = SFHOMEURL.'index.php?sp_ahah=plupload-manage&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;action=remove-photo&amp;uid='.$userid.'&amp;fid='.urlencode($photo['file']);
                $out.= '<td class="spPlupPhotoDel"><img onclick="spPlupDelPhoto(\''.$site.'\', \'sp-photo-'.$index.'\')" src="'.SFCOMMONIMAGES.'delete.png" /></td>';
                $out.= '</tr>';
            }
        }
        $out.= '</table>';
    } else {
        $out.= __('No photos currently uploaded', 'sp-plup');
    }

    global $formStart;
    return $formStart.$out.sp_plupload_do_uploader_form('', '', $userid, '', 'photos');
}

?>